package rip.tilly.bedwars.providers.tablist;

import club.frozed.tablist.adapter.TabAdapter;
import club.frozed.tablist.entry.TabEntry;
import club.frozed.tablist.skin.Skin;
import com.google.common.collect.Lists;
import com.mojang.authlib.GameProfile;
import com.mojang.authlib.properties.Property;
import org.bukkit.Bukkit;
import org.bukkit.craftbukkit.v1_8_R3.entity.CraftPlayer;
import org.bukkit.entity.Player;
import rip.tilly.bedwars.BedWars;
import rip.tilly.bedwars.playerdata.PlayerData;
import rip.tilly.bedwars.utils.CC;

import java.util.List;

public class TablistProvider implements TabAdapter {

    private final BedWars plugin = BedWars.getInstance();

    @Override
    public String getHeader(Player player) {
        return CC.translate("&d&lTilly RIP &7┃ &fBedWars");
    }

    @Override
    public String getFooter(Player player) {
        return CC.translate("&7tilly.rip");
    }

    @Override
    public List<TabEntry> getLines(Player player) {
        List<TabEntry> lines = Lists.newArrayList();
        int column = 0;
        int row = 0;
        for (Player online : Bukkit.getOnlinePlayers()) {
            if (online == null) {
                break;
            }
            GameProfile onlineSkin = ((CraftPlayer) online).getProfile();
            Property onlineProperty = onlineSkin.getProperties().get("textures").stream().findFirst().orElse(null);

            assert onlineProperty != null;
            lines.add(new TabEntry(column, row, online.getDisplayName()).setPing(((CraftPlayer) online).getHandle().ping).setSkin(new Skin(onlineProperty.getValue(), onlineProperty.getSignature())));
            if (column++ < 2) {
                continue;
            }
            column = 0;
            if (row++ < 19) {
                continue;
            }
            row = 0;
        }

        GameProfile skin = ((CraftPlayer) player).getProfile();
        Property property = skin.getProperties().get("textures").stream().findFirst().orElse(null);

        PlayerData playerData = this.plugin.getPlayerDataManager().getPlayerData(player.getUniqueId());

        lines.add(new TabEntry(3, 2, CC.translate("&d&lYour Profile")).setPing(-1).setSkin(new Skin(property.getValue(), property.getSignature())));
        lines.add(new TabEntry(3, 3, CC.translate(" &fKills: &d" + playerData.getKills())).setPing(-1));
        lines.add(new TabEntry(3, 4, CC.translate(" &fDeaths: &d" + playerData.getDeaths())).setPing(-1));

        return lines;
    }
}
